<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

include_once '../cms/fastix_funktionen.php';
include_once '../cms/fastix_template.php';
include_once 'getAdminMenueLinks.php';

$arTemplate['CSSFile']='../skins/fastix/css/css.php';
$arTemplate['MenueLinks']=getAdminMenueLinks();
$arTemplate['TemplateFile']='../skins/fastix/templates/admin.html';
$arTemplate['imgDir']='../skins/fastix/img/';
$arTemplate['Seitentitel']='Artikel verwalten';
$arTemplate['SeitentitelHTML']=$arTemplate['Seitentitel'];
$arTemplate['SeitentitelKurz']=$arTemplate['Seitentitel'];

$_SESSION['editor.backurl']='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$arTemplate['JavaScript']='';
$arTemplate['Seiteninhalt']='';


$arKategorien=fastixGetKategorien();
$filename='../data/artikel.csv';
#die ('AdminArtikel.php: Zeile 27: '.$filename);
$arArtikel=fastixCsvToAssocArray($filename,';','#',6);
$strKategorieListe2='';

$arKeys=array_keys($arKategorien);
$arArtKeys=array();
foreach ($arKeys as $key) {
	$kategorie=$arKategorien[$key];
	$kategorie[0]=$key;
	$arArtKeys=array_keys($arArtikel);
	#fastixDebugArray($kategorie);
	$strKategorieListe2.='<tr>
	<td colspan="3">&nbsp;</td>
<tr style="background-color:#fbe7d0">
	<th  class="text" style="padding-left:1em;">'.$kategorie[3].'</th><th><input type="button" class="editItem" onclick="editKategorie('.$key.')" value="bearbeiten"></th>
	<td width="240px" style="background-color:#fbe7d0"><input type="button" class="newItem" onclick="neuerArtikel('.$key.')" value="neuer Artikel"></td>
</tr>
';
	foreach ($arArtKeys as $artNr) {
		if (true 
		&& isset($arArtikel[$artNr]) 
		&& isset($arArtikel[$artNr][1]) 
		&& $arArtikel[$artNr][1]==$kategorie[0]) {
			$bolFrei=(1==$arArtikel[$artNr][2]);			
			$strAutor=$arArtikel[$artNr][3];
			$strTitel=$arArtikel[$artNr][5];
			$strKategorieListe2.=getKategorieItem ($strAutor,$strTitel,$bolFrei,$artNr);
			$arArtikel[$artNr]='';
		}
		
	}
}


$strKategorieListe1='';
if ( count($arArtKeys) ) {
	foreach ($arArtKeys as $artNr) {
		if (isset( $arArtikel[$artNr]) && is_array($arArtikel[$artNr])) {
			$bolFrei=3;			
			$strAutor=$arArtikel[$artNr][3];
			$strTitel=$arArtikel[$artNr][5];
			$strKategorieListe1.=getKategorieItem ($strAutor,$strTitel,-1,$artNr);
		}
	}
}

if ('' != $strKategorieListe1) {
	$strKategorieListe1='
<tr>
	<td colspan="3" style="">&nbsp;</td>
</tr>
<tr>
	<th class="text" colspan="2">Nicht zugeordnete Artikel (Handlungsbedarf):</th>
	<td width="240px"></td>
</tr>
'.$strKategorieListe1;
}

$arTemplate['Seiteninhalt']='<table style="width:100%">'.$strKategorieListe1.$strKategorieListe2.'</table>';

if (isset($_SESSION['lastmsg'])) {
	$arTemplate['JavaScript']='
	<script type="text/javascript">
		alert("'.$_SESSION['lastmsg'].'")
	</script>
';
	unset($_SESSION['lastmsg']);
}
$arTemplate['JavaScript'].=file_get_contents('AdminArtikel.js');

PrintFastixTemplateReplace($arTemplate);
exit;

function getKategorieItem ($strAutor,$strTitel,$bolFrei,$artNr){

	$str='
	<tr>
		<td style="padding-left:2em">'.$strTitel.'</td>
		<td>('.$strAutor.')</td>
		<td>
			<input type="button" class="editItem" onclick="editArtikel('.$artNr.')" value="editieren" />
			<input type="button" class="deleteItem" onclick="loescheArtikel('.$artNr.')" value="löschen" />';
	
	if (0==$bolFrei) {
		$str.='
			<input type="button" class="changeItem" onclick="freigabeArtikel('.$artNr.')" value="frei geben">';
	} else if (1==$bolFrei) {
		$str.='
			<input type="button"  class="changeItem" onclick="sperreArtikel('.$artNr.')" value="sperren">';
	} 
	$str.='</td>
	</tr>';
return $str;
}
?>