<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

include_once '../cms/fastix_funktionen.php';
include_once '../cms/fastix_template.php';
include_once 'getAdminMenueLinks.php';

$GLOBALS['intSeitenGroesse']	= 8;
$GLOBALS['PicFile']		= '../data/bildshow.csv'; #sog. Datenbank
$GLOBALS['KatFile']		= '../data/bildshow_kategorien.csv';
$GLOBALS['PicFileDelimiter']	= '~';
$GLOBALS['PicFilesDir']		= '../bilder/';
$GLOBALS['ThumbFilesDir']	= $GLOBALS['PicFilesDir'].'thumbnails/';
$GLOBALS['originalFilesDir']	= $GLOBALS['PicFilesDir'].'original/';
$GLOBALS['ColsInThumTable']	= 2;

#fastixDebugArray($GLOBALS, true);

$arTemplate['CSSFile']='../skins/fastix/css/css.php';
$arTemplate['MenueLinks']=getAdminMenueLinks();
$arTemplate['TemplateFile']='../skins/fastix/templates/admin.html';
$arTemplate['imgDir']='../skins/fastix/img/';
$arTemplate['Seitentitel']='Bilder verwalten';
$arTemplate['SeitentitelHTML']=$arTemplate['Seitentitel'];
$arTemplate['SeitentitelKurz']=$arTemplate['Seitentitel'];

$_SESSION['editor.backurl']='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$arTemplate['JavaScript']=file_get_contents('AdminBilder.js');
$arTemplate['Seiteninhalt']='';


## Abschalten der Kategorien:
if (isset($_REQUEST['kategorie'])) {
	if (isset($_GET['kategorie']))		{ unset($_GET['kategorie']); }
	if (isset($_POST['kategorie']))		{ unset($_POST['kategorie']); }
	if (isset($_COOKIE['kategorie']))	{ unset($_COOKIE['kategorie']);}
	unset($_REQUEST['kategorie']);
}


## RUN

## Heraussuchen der Bilder:
$GLOBALS['arBilder']=getImagesArray();

$GLOBALS['intAnzahlBilder']=count($GLOBALS['arBilder']);
$GLOBALS['intAnzahlSeiten']=floor(0.999999999*$GLOBALS['intAnzahlBilder']/$GLOBALS['intSeitenGroesse'])+1;

$aktBild=1; #Aktuell anzuzeigendes Bild

if (isset($_GET['nr'])) {
	$aktBild=$_GET['nr'];
}

$aktSeite=floor(($aktBild-1)/$GLOBALS['intSeitenGroesse'])+1;
$erstesBild=($aktSeite-1)*$GLOBALS['intSeitenGroesse']+1;
$letztesBild=$aktSeite*$GLOBALS['intSeitenGroesse'];
if ($letztesBild > $GLOBALS['intAnzahlBilder']) {
	$letztesBild=$GLOBALS['intAnzahlBilder'];
}

$arTemplate['aktuellesBild']=$aktBild;
$arTemplate['Bilderwahlleiste']=getBilderLinks ($erstesBild, $letztesBild, $aktBild);
$arTemplate['Seitenwahlleiste']=getSeitenLinks($aktSeite);

$arTemplate['Bilder_X_Y']='Bilder '.$erstesBild.'-'.$letztesBild;
#$arTemplate['buskeismus']=file_get_contents($arTemplate['include_1']);
$arTemplate['buskeismus']='';
$arTemplate['aktJahr']=date('Y');

$arTemplate['BildZurueck']='<span style="color:#999">zur&uuml;ck</span>';
if ($aktBild > 1) {
	$arTemplate['BildZurueck'] = '<a href="?nr='.($aktBild-1).'" style="">zur&uuml;ck</a>';
}

$arTemplate['BildVor']='<span style="font-size:1em; color:#999">weiter</span>';
if ($aktBild+1 < $GLOBALS['intAnzahlBilder']) {
	$arTemplate['BildVor'] = '<a href="?nr='.($aktBild+1).'"  style="">weiter</a>';
}	

$arTemplate['SeiteZurueck']='<span style="color:#999;">zur&uuml;ck</span>';
if ($aktSeite > 1) {
	$arTemplate['SeiteZurueck'] = '<a href="?nr='.(($aktSeite-2)*$GLOBALS['intSeitenGroesse']+1).'" style="">zur&uuml;ck</a>';
}

$arTemplate['SeiteVor']='<span style="color:#999;">weiter</span>';
if ($aktSeite < $GLOBALS['intAnzahlSeiten']) {
	$arTemplate['SeiteVor'] = '<a href="?nr='.(($aktSeite)*$GLOBALS['intSeitenGroesse']+1).'" style="">weiter</a>';
}

$search=array('_',	'-',	'.jpg',	'.png',	'.jpeg',	'.gif');
$replace=array(' ',	' - ',	'',	'',	'',		'');
list($PicRealWidth,$PicRealHeight)=getRealSize($aktBild);

if (isset($GLOBALS['arBilder'][$aktBild]['file'])) {
	$titelFromFilename=ucwords(str_replace($search, $replace, $GLOBALS['arBilder'][$aktBild]['file']));
} else {
	$titelFromFilename='';
}


	$arTemplate['Seiteninhalt'] .=
'
<div  style="width:250px;float:right">
<input type="button" value="Aufgaben" onclick="wechselShow(\'w_aufgaben\')" />
<input type="button" value="Auswahl" onclick="wechselShow(\'w_thumbnails\')" />
	<div id="wechsel">
	</div>
</div>

<div style="width:450px;margin:0;padding:0">
	<form name="upload" id="upload" action="AdminBilderUpload.php" method="post" enctype="multipart/form-data" style="margin-bottom:.5em">
		<fieldset>
			<legend>Neues Bild hochladen:</legend>
			<input style="background-color:#fbe7d0 " name="file" type="file" size="42"><br>
			<input name="test" type="hidden" value="42">
			<input class="newItem" style="margin-top:.5em" type="submit" value="Bild hochladen">
		</fieldset>
	</form>
';
if (isset($GLOBALS['arBilder'][$aktBild])) {
	$arTemplate['Seiteninhalt'] .='
	
	<form method="post" action="AdminBilderUpdate.php" name="daten" id="daten">
	<img 
	src="'.$GLOBALS['PicFilesDir'].$GLOBALS['arBilder'][$aktBild]['file'].'"	
	style="border:0 width:'.$PicRealWidth.'px; height:'.$PicRealHeight.'px;" 
	alt="'.$GLOBALS['arBilder'][$aktBild]['file'].'" 
	title="'.$GLOBALS['arBilder'][$aktBild]['titel'].'" >
	<div style="margin-top:.5em; margin-bottom:.5em;">
	<input type="hidden" name="filename" value="'.$GLOBALS['arBilder'][$aktBild]['file'].'" />
		<input type="button" class="deleteItem" value="Bild löschen" onclick="loescheBild('.$aktBild.')" />
		<input type="button" class="editItem" value="in Originalgröße anzeigen" onclick="zeigeBild(\''.$GLOBALS['httpBase'].'../bilder/original/'.$GLOBALS['arBilder'][$aktBild]['file'].'\')" />
	</div>
	<div style="border:1px solid #ff8901; padding:.2em; background-color:#fbe7d0">'.$GLOBALS['arBilder'][$aktBild]['file'].'</div>
	
	<div style="margin-top:.5em; font-weight:bold">Datei:</div>
	<div style="border:1px solid #ff8901; padding:.2em; background-color:#fbe7d0">'.$GLOBALS['arBilder'][$aktBild]['file'].'</div>
	
	<div style="margin-top:.5em; font-weight:bold">html-text zum Einfügen:</div>
	
	<div style="border:1px solid #ff8901; padding:.2em; background-color:#fbe7d0">&lt;a href=&quot;/bilder/original/'.$GLOBALS['arBilder'][$aktBild]['file'].'&quot;&gt;&lt;img src=&quot;/bilder/'.$GLOBALS['arBilder'][$aktBild]['file'].'&quot; alt=&quot;'.$GLOBALS['arBilder'][$aktBild]['file'].'&quot; title=&quot;'.$GLOBALS['arBilder'][$aktBild]['titel'].'&quot; style=&quot;height:'.$PicRealHeight.'px; width:'.$PicRealWidth.'px;border:0&quot;  /&gt;&lt;/a&gt;</div>
	
	
	<div style="margin-top:.5em; font-weight:bold">Titel: </div>
	<input name="titel" id="btitel" type="text" style="width:100%" value="'.str_replace('"', '&quot;',$GLOBALS['arBilder'][$aktBild]['titel']).'" />
	
	<input id="bautor" name="autor" type="hidden" value="" />
	<input type="hidden" id="bdesc" name="beschreibung" value=""> 
	<input type="hidden" name="filename" value="'.$GLOBALS['arBilder'][$aktBild]['file'].'" />
	<input type="hidden" name="id" value="'.$aktBild.'" />
	<div style="margin-top:.5em">
		<input type="submit" value="speichern" />
		<input type="reset" />
		<input type="button" value="aus Dateiname erzeugen" onclick="document.getElementById(\'btitel\').value=\''.$titelFromFilename.'\'">
	</div>	
	</form>
';
}

$arTemplate['Seiteninhalt'] .='
</div>

<div id="w_aufgaben" style="display:none">
	<h2>Aufgaben:</h2>
		<form name="backup" action="AdminBilderBackup.php" method="post"><input type="hidden" name="id" value="'.$aktBild.'" />
		<fieldset><legend>Backup der Datenbank anlegen!</legend>
			<input type="submit" value="Backup anlegen!">
		</fieldset>
	</form>
</div>


<div id="w_thumbnails" style="display:none">
	<table style="width:100%; margin-top:1em">
		<tr><th>Seiten:</th></tr>
		<tr>
			<td style="width:3em">'.$arTemplate['SeiteZurueck'].'</td>
			<td>'.$arTemplate['Seitenwahlleiste'].'</td>
			<td style="width:3em">'.$arTemplate['SeiteVor'].'</td>
		</tr>
	</table>
	<table>
		'.getThumbnails($erstesBild, $letztesBild, '').'
	</table>
</div>


<script type="text/javascript">
// <--
document.getElementById(\'inhalt\').style.right="1em";
wechselShow("w_thumbnails");
// -->
</script>

';


PrintFastixTemplateReplace($arTemplate);
exit;


/*
## Funktionen:
*/


function getImagesArray() {
	$arZeilen=file($GLOBALS['PicFile']);
	# Einlesen und Pruefen des Bilder-Arrays aus der Datei:
	$i=0; $arBilder=array();
	foreach ($arZeilen as $strZeile) {
		$arSpalten=array();
		$arSpalten=explode($GLOBALS['PicFileDelimiter'], $strZeile);
		if ( true
			AND (isset ($arSpalten[0]) AND '' != $arSpalten[0])
			AND (isset ($arSpalten[1]))
			AND (isset ($arSpalten[2]))
		) {
			$i++;
			$arBilder[$i]['file']=$arSpalten[0];
			$arBilder[$i]['autor']=$arSpalten[1];
			$arBilder[$i]['titel']=$arSpalten[2];
			
			if (isset ($arSpalten[3])) {
				$arBilder[$i]['autorBeschreibung']=$arSpalten[3]; 
			} else {
				$arBilder[$i]['autorBeschreibung']=false;
			}
			
			if (isset ($arSpalten[4])) {
				$arBilder[$i]['bildBeschreibung']=$arSpalten[4];
			} else {
				$arBilder[$i]['bildBeschreibung']=false;
			}
			
			if (isset ($arSpalten[5])) {
				$arBilder[$i]['bildJahr']=$arSpalten[5]; 
			} else {
				$arBilder[$i]['bildJahr']=false;
			}
			
			if (isset ($arSpalten[6])) {
				$arBilder[$i]['zahl1']=$arSpalten[6]; 
			} else {
				$arBilder[$i]['zahl1']=false;
			}
			
			if (isset ($arSpalten[7])) {
				$arBilder[$i]['zahl2']=$arSpalten[7];
			} else {
				$arBilder[$i]['zahl2']=false;
			}
			
			if (isset ($arSpalten[8])) {
				$arBilder[$i]['kategorie']=$arSpalten[8];
			} else {
				$arBilder[$i]['kategorie']=false;
			}
		}
	}
	return $arBilder;
}



function getBilderLinks ($erstesBild, $letztesBild, $aktBild) {
	$ret='';
	for ($i=$erstesBild; $i<=$letztesBild; $i++) {
		if (isset($GLOBALS['arBilder'][$i])) {
			if($i==$aktBild) {
				$ret.='<span style="color:red;">'.$i.'</span>&nbsp;&nbsp;';
			} else {
				$ret.= '<a href="?nr='.$i.'" style="">'.$i.'</a>&nbsp;&nbsp;';
			}
		}
	}
	return $ret;
}

function getSeitenLinks($aktSeite) {
	$ret='';
	for($m=1; $m<=$GLOBALS['intAnzahlSeiten']; $m++) {
		if($m==$aktSeite) {
			$ret.= '<span style="color:red;">'.$m.'</span> ';
		} else {
			$nr=($m-1)*$GLOBALS['intSeitenGroesse']+1;
			if (isset($GLOBALS['arBilder'][$nr])) {
				$ret.= '<a href="?nr=' . $nr . '" style="">' .$m. '</a>&nbsp;';
			}
		}
	}
	return $ret;
}

function getThumbnails ($erstesBild, $letztesBild, $artist) {
	$str='';
	for ($i=$erstesBild; $i<=$letztesBild; $i++) {
		if (isset($GLOBALS['arBilder'][$i])) {
			if (0==$i || 0 != ($i%$GLOBALS['ColsInThumTable'])) {
				$str.='<tr><td colspan="'.$GLOBALS['ColsInThumTable'].'" style="height:15px">&nbsp;</td></tr><tr>'."\n";
			}
				
			$desc=$artist.', '.$GLOBALS['arBilder'][$i]['titel'];
			$str.='
	<td style="width:50%;vertical-align:bottom">
	<p><a href="?nr='.$i.'"><img src="'.$GLOBALS['ThumbFilesDir'].$GLOBALS['arBilder'][$i]['file'].'"
	alt="'.$desc.'" 
	title="'.$desc.'" 
	style="border:0"></a>&nbsp;&nbsp;</p>
	<p>'.$GLOBALS['arBilder'][$i]['titel'].'</p>
	</td>
	';
			
			if ($i > 0 && 0==($i%$GLOBALS['ColsInThumTable'])) {
				$str.='</tr>'."\n";
			}
		}
	}
	return $str;
}


function getRealSize ($aktBild) {
	$search = 'http://'.$_SERVER['SERVER_NAME'];
	$replace= $_SERVER['DOCUMENT_ROOT'];
	$picdir   = str_replace($search, $replace, $GLOBALS['PicFilesDir']);
	if (	true
		&& isset($GLOBALS['arBilder'][$aktBild]['file'])
		&& file_exists ($picdir.$GLOBALS['arBilder'][$aktBild]['file'])
	) {
		$ar=getimagesize($picdir.$GLOBALS['arBilder'][$aktBild]['file']);
		return array($ar[0],$ar[1]);
	} else  {
		return array(false, false);
	}
}

?>