<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

include_once 'fastix_funktionen.php';
include_once 'getAdminMenueLinks.php';

$GLOBALS['intSeitenGroesse']	= 8;
$GLOBALS['PicFile']		= '../data/bildshow.csv'; #sog. Datenbank
$GLOBALS['KatFile']		= '../data/bildshow_kategorien.csv';
$GLOBALS['PicFileDelimiter']	= '~';
$GLOBALS['PicFilesDir']		= '../bilder/';
$GLOBALS['ThumbFilesDir']	= $GLOBALS['PicFilesDir'].'thumbnails/';
$GLOBALS['originalFilesDir']	= $GLOBALS['PicFilesDir'].'original/';
$GLOBALS['ColsInThumTable']	= 2;

# test auf Fehler:
if ($_FILES['file']['error']) {
	die ('Beim Hochladen trat ein Fehler auf. Versuchen Sie es erneut');
}

# Test auf Bild:
if ($_FILES['file']['type'] != 'image/jpeg'
&& $_FILES['file']['type'] != 'image/jpg' 
&& $_FILES['file']['type'] != 'image/png' 
&& $_FILES['file']['type'] != 'image/bmp' 
&&  $_FILES['file']['type'] != 'image/gif' 
) {
	die ('Die hochgeladene Datei ist kein JPG/PNG/GIF-Bild.');
} 

# Test auf Dateigröße:
if ($_FILES['file']['size'] < 100) {
	die ('Die hochgeladene Datei ist zu klein. Laden Sie eine größere Version hoch.');
} 

if ((! function_exists("imagecreatefromgif")) && $_FILES['file']['type'] != 'image/gif') {
	die ('Die hochgeladene Datei ist ein GIF-Bild, dass aus patentrechtlichen Gründen leider nicht verarbeitet werden kann. <br><br>Lösung:<br>Laden Sie eine andere Version des Bildes (.jpg, .png oder .bmp) hoch.');
}

$picdir      = $GLOBALS['PicFilesDir'];
$thumbdir    = $GLOBALS['ThumbFilesDir'];
$originaldir = $GLOBALS['originalFilesDir'];

if ($_FILES['file']['type'] == 'image/jpeg' OR $_FILES['file']['type'] == 'image/jpg') {
	$image = imagecreatefromjpeg($_FILES['file']['tmp_name']);
	$_FILES['file']['name']=str_replace('.jpg','.png',$_FILES['file']['name']);
	$_FILES['file']['name']=str_replace('.JPG','.png',$_FILES['file']['name']);	
	$_FILES['file']['name']=str_replace('.jpeg','.png',$_FILES['file']['name']);	
}
if ($_FILES['file']['type'] == 'image/png') {
	$image = imagecreatefrompng($_FILES['file']['tmp_name']);
}
if ($_FILES['file']['type'] == 'image/bmp') {
	$image = imagecreatefromwbmp($_FILES['file']['tmp_name']);
	$_FILES['file']['name']=str_replace('.png','.png',$_FILES['file']['name']);	
	$_FILES['file']['name']=str_replace('.PNG','.png',$_FILES['file']['name']);
}
if ($_FILES['file']['type'] == 'image/gif') {
	$image = imagecreatefromgif($_FILES['file']['tmp_name']);
	$_FILES['file']['name']=str_replace('.gif','.png',$_FILES['file']['name']);	
	$_FILES['file']['name']=str_replace('.GIF','.png',$_FILES['file']['name']);
}

list($width_orig, $height_orig) = getimagesize($_FILES['file']['tmp_name']);

if (file_exists($picdir.$_FILES['file']['name'])) {
  $fileNameExtra='_'.date('YmdHis');
  $_FILES['file']['name']=$_FILES['file']['name'].$fileNameExtra;
} else {
	$fileNameExtra=false;
}


# Bild auf 450px breite verkleinern und in bilder speichern

$width=450; 
if ($width >= $width_orig) {
	$width=$width_orig;
	$height=$height_orig;
} else {
	$faktor=$width/$width_orig;
	$height=$height_orig*$faktor;
}
$image_p = imagecreatetruecolor($width, $height);
$weiss = imagecolorallocate($image_p, 255, 255, 255);
imagefilledrectangle($image_p, 0, 0, $width, $height, $weiss);
$trans_colour = imagecolorallocatealpha($image_p, 255, 255, 255, 127);
imagefill($image_p, 0, 0, $trans_colour);

imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
imagepng($image_p, $picdir.$_FILES['file']['name'],3);

# Bild auf 125px breite verkleinern und in thumbnails speichern

$width=120;
if ($width > $width_orig) {
	$width=$width_orig;
	$height=$height_orig;
} else {
	$faktor=$width/$width_orig;
	$height=$height_orig*$faktor;
}
$image_p = imagecreatetruecolor($width, $height);
$weiss = imagecolorallocate($image_p, 255, 255, 255);
imagefilledrectangle($image_p, 0, 0, $width, $height, $weiss);
$trans_colour = imagecolorallocatealpha($image_p, 255, 255, 255, 127);
imagefill($image_p, 0, 0, $trans_colour);

imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width, $height, $width_orig, $height_orig);
imagepng($image_p, $thumbdir.$_FILES['file']['name'],9);

# Speichern des Bildes in Original-Größe:
$image_p = imagecreatetruecolor($width_orig, $height_orig);
$weiss = imagecolorallocate($image_p, 255, 255, 255);
imagefilledrectangle($image_p, 0, 0, $width_orig, $height_orig, $weiss);
$trans_colour = imagecolorallocatealpha($image_p, 255, 255, 255, 127);
imagefill($image_p, 0, 0, $trans_colour);

imagecopyresampled($image_p, $image, 0, 0, 0, 0, $width_orig, $height_orig, $width_orig, $height_orig);
imagepng($image_p, $originaldir.$_FILES['file']['name'],1);

# Löschen des Uploads
unlink ($_FILES['file']['tmp_name']);

# Daten f�r CSV
$author='';
$search=array('_',	'-',	'.png'	,	'~');
$replace=array(' ',	' - ',	''	,	''	,	'');

$title=$_FILES['file']['name'];
if ($fileNameExtra) {
	$title=str_replace($fileNameExtra, '', $title);
}
$title=ucwords(str_replace($search, $replace, $title));

$type='';		

list($width, $height) = getimagesize($thumbdir.$_FILES['file']['name']);
$jahr='';
if ($width > $height) {
	$desc='querformat';
} else {
	$desc='hochformat';
}
$kategorie='0';
$file=$_FILES['file']['name'];

$csv="\n$file~$author~$title~$type~$desc~$jahr~$width~$height~$kategorie";
$FH=fopen($GLOBALS['PicFile'], 'a') or die('ging nicht!');
fwrite($FH, $csv);
fclose($FH);

$imgNr=count(file($GLOBALS['PicFile']));
header('Location: AdminBilder.php?nr='.$imgNr);
?>