<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

include_once '../cms/fastix_funktionen.php';
include_once '../cms/fastix_template.php';
include_once 'getAdminMenueLinks.php';

$arTemplate['CSSFile']='../skins/fastix/css/css.php';
$arTemplate['MenueLinks']=getAdminMenueLinks();
$arTemplate['TemplateFile']='../skins/fastix/templates/admin.html';
$arTemplate['imgDir']='../skins/fastix/img/';
$arTemplate['Seitentitel']='Termine verwalten';
$arTemplate['SeitentitelHTML']=$arTemplate['Seitentitel'];
$arTemplate['SeitentitelKurz']=$arTemplate['Seitentitel'];

$_SESSION['editor.backurl']='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$arTemplate['JavaScript']='';
$arTemplate['Seiteninhalt']='';


# Daten einlesen
$arTermine=fastixCsvToArray('../data/termine.csv', ';', '#', 5);
#Ermitteln des Startzeitpunktes:

$arAssocTermine=array();
foreach ($arTermine as $tmp) {
	$tmp[0]=strtotime($tmp[0]);
	$tmp[1]=strtotime($tmp[1]);
	$arAssocTermine[$tmp[1]]=$tmp;
}
unset($arTermine);
$GLOBALS['f_counter']=0;
$arAlteTermine=array();
$arAktelleTermine=array();

$heute=strtotime(date('Y-m-d'));
$arKeys=array_keys($arAssocTermine);

if (count($arKeys)) {
	foreach ($arKeys as $key) {
		if ($key >=$heute) {
			$arAktelleTermine[$key]=$arAssocTermine[$key];
		} else {
			$arAlteTermine[$key]=$arAssocTermine[$key];
		}
	}
}
unset($arAssocTermine);

#Einlesen der Artikel für Test
$arArtikel=fastixCsvToArray('../data/artikel.csv', ';', '#', 6);
#fastixDebugArray($arArtikel, true);


if (count($arAktelleTermine)) {
	ksort($arAktelleTermine,SORT_NUMERIC);
	#fastixDebugArray($arAktelleTermine, false);
	$strAktelleTermine='
	<h2>Aktuelle Termine:</h2>
	<ul>
	'.formatTermine($arAktelleTermine,$arArtikel).'
	</ul>
	';
	#fastixDebugArray($strAktelleTermine, false);
} else {
	$strAktelleTermine=false;
}
unset($arAktelleTermine);



if (count($arAlteTermine)) {
	krsort($arAlteTermine,SORT_NUMERIC);
	#fastixDebugArray($arAlteTermine, false);
	$strAlteTermine='<h2>Frühere Termine:</h2>
	<ul>
	'.formatTermine($arAlteTermine,$arArtikel).'
	</ul>
	';
	#fastixDebugArray($strAlteTermine, false);
} else {
	$strAlteTermine=false;
}

#fastixDebugArray($strAlteTermine, true);

$fileEditButton='<div><input type="button" class="editItem" value="Seite bearbeiten" onclick="window.location.href=\'./editor.php?item=Kategorien/Termine.html&type=html\'"></div>';

$neuerTermin='
<h2>Neuer Termin:</h2>
<form name="neu" action="AdminTermineSpeichern.php" method="POST" style="border:2px solid #ff8901; padding: 0.5em; margin-top: 1.5em; line-height: 2em;-moz-border-radius:3px;border-radius:3px;">
Termin:
<input name="titel" value="Neuer Titel" type="text" style="width:100%;font-site:14px"><br>
<strong>vom:</strong> <input name="beginn_Tag" style="width: 2em;" size="2" value="'.date('d').'" type="text">.<input name="beginn_Monat" style="width: 2em;" size="2" value="'.date('m').'" type="text">.<input name="beginn_Jahr" style="width: 4em;" size="4" value="'.date('Y').'" type="text"> um <input name="beginn_Stunde" style="width: 2em;" size="2" value="00" type="text">:<input name="beginn_Minute" style="width: 2em;" size="2" value="00" type="text"> Uhr<br>
<strong>bis:&nbsp;&nbsp;</strong> <input name="ende_Tag" style="width: 2em;" size="2" value="'.date('d').'" type="text">.<input name="ende_Monat" style="width: 2em;" size="2" value="'.date('m').'" type="text">.<input name="ende_Jahr" style="width: 4em;" size="4" value="'.date('Y').'" type="text"> um <input name="ende_Stunde" style="width: 2em;" size="2" value="00" type="text">:<input name="ende_Minute" style="width: 2em;" size="2" value="00" type="text"> Uhr<br><br>
'.getArtikelSelector('', $arArtikel).'<br>
<br>
<input name="neu" value="anlegen" class="newItem" type="submit">
<input class="changeItem" type="reset"></form>
';

unset($arAlteTermine);
unset($arArtikel);

$arTemplate['Seiteninhalt']=file_get_contents('../data/Kategorien/Termine.html').$fileEditButton.$neuerTermin.$strAktelleTermine.$strAlteTermine;


function formatTermine($ar, $arArtikel) {
	$str='';
	foreach ($ar as $tupel) {
		$GLOBALS['f_counter']++;
		$buttons='<br>
		<input name="speichern" class="editItem" type="submit" value="speichern" />
		<input type="button" class="changeItem" onclick="hideForm('.$GLOBALS['f_counter'].')" value="abbrechen" />
		<input type="submit" class="deleteItem" value="löschen" name="loeschen" />';

		$beginn=fastixFormatTimeString($tupel[0]);
		$ende=  fastixFormatTimeString($tupel[1]);
		if ($ende==$beginn) {
			$ende='';
		} else {
			$ende=' bis '.$ende;
		}
		$ArtNr=$tupel[2];
				
		$str.='<li><a id="l_'.$GLOBALS['f_counter'].'"  href="javascript:showForm('.$GLOBALS['f_counter'].')">'.$beginn.$ende.': '.$tupel[3]."</a>\n";
	
		$beginn=getDatumFormElements($tupel[0],'beginn_');
		$ende=  getDatumFormElements($tupel[1],'ende_');
		$ArtNr=$tupel[2];
		$titel=$tupel[3];
	
		$str.='
<form id="f_'.$GLOBALS['f_counter'].'" name="f_'.$GLOBALS['f_counter'].'" action="AdminTermineSpeichern.php" method="POST" style="border:2px solid #ff8901; padding: 0.5em; margin-top: 1.5em; line-height: 2em; -moz-border-radius:3px; border-radius:3px; display:none">
Bearbeiten:
<h3 style="margin-bottom:.5em; margin-top:-.5em;padding:0">'.$titel.'</h3>
<strong>vom:</strong> '.$beginn.'<br>
<strong>bis:&nbsp;&nbsp;</strong> '.$ende.'<br><br>
'.getArtikelSelector($ArtNr, $arArtikel).'<br>
<input type="hidden" name="titel" value="'.$titel.'" />
'.$buttons.'</form>
</li>
';
	}
	
	return $str."\n";
}


$arTemplate['JavaScript']='';
if (isset($_SESSION['lastmsg'])) {
	$arTemplate['JavaScript']='
	<script type="text/javascript">
		alert("'.$_SESSION['lastmsg'].'")
	</script>
';
	unset($_SESSION['lastmsg']);
}
$arTemplate['JavaScript'].=file_get_contents('AdminTermine.js');

PrintFastixTemplateReplace($arTemplate);
exit;


function getDatumFormElements($t,$pre) {
	$strTag  ='<input name="'.$pre.'Tag" type="text" style="width:2em" size="2" value="'.date('d',$t).'">';
	$strMonat='<input name="'.$pre.'Monat" type="text" style="width:2em" size="2" value="'.date('m',$t).'">';	
	$strJahr ='<input name="'.$pre.'Jahr" type="text" style="width:4em" size="4" value="'.date('Y',$t).'">';
	$strStunde ='<input name="'.$pre.'Stunde" type="text" style="width:2em" size="2" value="'.date('H',$t).'">';
	$strMinute ='<input name="'.$pre.'Minute" type="text" style="width:2em" size="2" value="'.date('i',$t).'"> Uhr';

	$str=$strTag.'.'.$strMonat.'.'.$strJahr.' um '.$strStunde.':'.$strMinute;
	return $str;
}

function getArtikelSelector($nr, $arArtikel) {
	$str='<strong>Verknüpfter Artikel:</strong> <select name="artikel"><option value="-1">keiner</option>';
	foreach ($arArtikel as $tupel) {
		$selected='';
		#fastixDebugArray($tupel, true);
		if ($nr==$tupel[0]) {
			$selected=' selected="selected" ';
		}
		$text=$tupel[5];
		$str.='<option value="'.$tupel[0].'"'.$selected.'>'.$text.'</option>';
	}
	$str.='</select>';
	#fastixDebugArray(array($nr,$tupel,$str), true);
	return $str;
}

?>