<?php
/*
AdminTermineSpeichern.php
*/


error_reporting(E_ALL);
include_once 'fastix_funktionen.php';
session_start();

#fastixDebugArray($_POST, true);

if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

$arCsv=fastixCsvToArray('../data/termine.csv', ';', '#', 4);

$arTermine=array();
foreach ($arCsv as $tupel) {
	$titel=trim($tupel[3]);
	unset($tupel[3]);
	$arTermine[$titel]=$tupel;
}

if (isset($_POST['titel'])) {
	$titel=trim($_POST['titel']);
	if (get_magic_quotes_gpc()) {
		$titel=stripslashes($_POST['titel']);
	}
	$titel=htmlspecialchars($titel);
	if (''==$titel or 'Neuer Titel'==$titel) {
		die ('
			<script type="text/javascript">
			alert ("Nichts zu speichern");
			history.back();
			</script>
		');
	}
}

if (isset($_POST['neu']) && 'anlegen'==$_POST['neu']) {

	if (isset ($arTermine[$titel])) {
		die ('
			<script type="text/javascript">
			alert ("Ein Termin mit diesem Titel existiert bereits. Geben Sie einen anderen Titel an.");
			history.back();
			</script>
		');
	}

	$arTermine[$titel]=array();
	$beginn=checkjahr($_POST['beginn_Jahr']).'-'.zweistellig($_POST['beginn_Monat']).'-'.zweistellig($_POST['beginn_Tag']).' '.zweistellig($_POST['beginn_Stunde']).':'.zweistellig($_POST['beginn_Minute']).':00';
	
	$intBeginn=checkjahr($_POST['beginn_Jahr']).zweistellig($_POST['beginn_Monat']).zweistellig($_POST['beginn_Tag']).zweistellig($_POST['beginn_Stunde']).zweistellig($_POST['beginn_Minute']).'00';	
	
	$ende=checkjahr($_POST['ende_Jahr']).'-'.zweistellig($_POST['ende_Monat']).'-'.zweistellig($_POST['ende_Tag']).' '.zweistellig($_POST['ende_Stunde']).':'.zweistellig($_POST['ende_Minute']).':00';
	$artikel=$_POST['artikel'];
	
	$intEnde=checkjahr($_POST['ende_Jahr']).zweistellig($_POST['ende_Monat']).zweistellig($_POST['ende_Tag']).zweistellig($_POST['ende_Stunde']).zweistellig($_POST['ende_Minute']).'00';
	
	if ( $intBeginn >= $intEnde ) {
		$ende=$beginn;
	}	
	
	$arTermine[$titel][0]=$beginn;
	$arTermine[$titel][1]=$ende;
	$arTermine[$titel][2]=$_POST['artikel'];
	WriteAndGo($arTermine,'Der Termin wurde gespeichert.');
}



if (isset($_POST['speichern']) && 'speichern'==$_POST['speichern']) {
	$beginn=checkjahr($_POST['beginn_Jahr']).'-'.zweistellig($_POST['beginn_Monat']).'-'.zweistellig($_POST['beginn_Tag']).' '.zweistellig($_POST['beginn_Stunde']).':'.zweistellig($_POST['beginn_Minute']).':00';
	
	$intBeginn=checkjahr($_POST['beginn_Jahr']).zweistellig($_POST['beginn_Monat']).zweistellig($_POST['beginn_Tag']).zweistellig($_POST['beginn_Stunde']).zweistellig($_POST['beginn_Minute']).'00';	
	
	$ende=checkjahr($_POST['ende_Jahr']).'-'.zweistellig($_POST['ende_Monat']).'-'.zweistellig($_POST['ende_Tag']).' '.zweistellig($_POST['ende_Stunde']).':'.zweistellig($_POST['ende_Minute']).':00';
	
	$intEnde=checkjahr($_POST['ende_Jahr']).zweistellig($_POST['ende_Monat']).zweistellig($_POST['ende_Tag']).zweistellig($_POST['ende_Stunde']).zweistellig($_POST['ende_Minute']).'00';
	
	
	$artikel=$_POST['artikel'];
	$arTermine[$titel][0]=$beginn;
	
	if ( $intBeginn >= $intEnde ) {
		$ende=$beginn;
	}
	
	$arTermine[$titel][1]=$ende;
	$arTermine[$titel][2]=$_POST['artikel'];
	WriteAndGo($arTermine,'Der Termin wurde gespeichert.');
}


if (isset($_POST['loeschen']) && 'löschen'==$_POST['loeschen']) {
 	unset($arTermine[$titel]);
	WriteAndGo($arTermine,'Der Termin wurde gelöscht'); 	
}

die('Datenfehler in $_POST.');
exit;

function WriteAndGo($arTermine,$msg) {
	$str=trim(implode("\n",fastixReadRemarksFromCsvAsArray ('../data/termine.csv','#')));
	$arKeys=array_keys($arTermine);
	foreach ($arKeys as $key) {
		$str.="\n".implode(';',$arTermine[$key]).';'.$key;
	}
	file_put_contents('../data/termine.csv', trim($str));
	$_SESSION['lastmsg']=$msg;
	header('Location: AdminTermine.php');
	exit;
}


function zweistellig ($z) {
	$z=$z*1;
	if ($z < 10) {
		return '0'.$z;
	} else {
		return $z;
	}
}

function checkjahr ($z) {
	$z=$z*1;
	if ($z < 2000) {
		return 2000+$z;
	} else {
		return $z;
	}
}
?>