<?php
require_once 'fastix_funktionen.php';
if (! function_exists('password_hash')) {
   require_once 'password_hash_compatibility.php';
}
session_start();

if ( (! isset($_SESSION['ADMIN'])) || (! isset($_SESSION['ROOT'])) || 0==isset($_SESSION['ROOT']) ) {
	header("HTTP/1.0 403 Forbidden");
	echo '<h1>Zugriff verboten</h1>';
	exit;
}

#fastixDebugArray($_POST, false);

$filename='../data/passwd.csv';
$dummy=fastixCheckFile($filename,'w');
$arCsv=fastixCsvToAssocArray($filename, $trenner=':', $remark='#', $maxCols=2);
#fastixDebugArray($arCsv, true);

$nameFromWeb=strtolower(trim($_REQUEST['admin'][$_REQUEST['i']]));
$passFromWeb=trim($_REQUEST['pass'][$_REQUEST['i']]);
if (''==$passFromWeb) {
	$_SESSION['lastmsg']='Das Passwort war leer. Keine Änderung gespeichert';
	header('Location: AdminUser.php');
	exit;
}

$passFromWeb=password_hash($passFromWeb, 1);
$arCsv[$nameFromWeb]=$passFromWeb;
#fastixDebugArray($arCsv, true);
$arRemarks=fastixReadRemarksFromCsvAsArray ($filename,$remark='#');
#fastixDebugArray($arRemarks, true);
$str_htpwasswd=trim(implode("\n", $arRemarks));
#fastixDebugArray($str_htpwasswd, true);

$keys=array_keys($arCsv);
#fastixDebugArray($keys, true);
foreach ($keys as $key) {
	$str_htpwasswd.="\n$key:".$arCsv[$key];
}
$str_htpwasswd=trim($str_htpwasswd);
#fastixDebugArray($str_htpwasswd, true);
$FH=fopen($filename,'w');
$dummy=flock($FH, LOCK_EX);
fwrite($FH,$str_htpwasswd);
fclose($FH);

#fastixDebugArray($_REQUEST, true);

$_SESSION['lastmsg']='Ihre Änderungen wurden gespeichert.';
header('Location: AdminUser.php');
?>