<?php
/*
edit.php
daten: 	type - Typ der zu editierenden Datei
	item: Name der editirenden Datei

*/
include_once 'fastix_funktionen.php';
session_start();

if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

@$filename='../'.$_SESSION['editor.filename'];


if ($_REQUEST['item']) {
	$find=array('..');
	$repl=array('');
	$filename='../data/'.str_replace($find,$repl,$_REQUEST['item']);
}

fastixCheckVerboteneSeiten($filename);

if (false
	|| $_REQUEST['type']=='flat'
	|| $_REQUEST['type']=='html'
	|| $_REQUEST['type']=='plain'
	|| $_REQUEST['type']=='csv'

) {
	$find=array('<'   , '>',   'src="bilder/');
	$repl=array('&lt;', '&gt;','src="../bilder/');
	@$file=str_replace($find,$repl,file_get_contents($filename));
	print '
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Editor für Benutzer '.$_SESSION['ADMIN'].'</title>
<link rel="Shortcut Icon" href="favicon.ico" />
<link rel="stylesheet" href="../skins/fastix/css/css.php" type="text/css"></link>
<script type="text/javascript" src="ckeditor/ckeditor.js"></script>
<script type="text/javascript">
function showPreview(elem) {
	document.getElementById("preview").innerHTML=document.forms[0].elements[3].value;
	document.forms[0].style.display="none";
	document.getElementById("previewEnvelope").style.display="block";

}
function disablePreviev () {
	document.getElementById("previewEnvelope").style.display="none";
	document.forms[0].style.display="block";
}
</script>
<style type="text/css">
#inhalt {
	top:90px;
}

#previewEnvelope {
	display:none;
	position:absolute;
	top:0;
	left:0;
	right:0;
	width:100%;
	padding:.1em;
}
.previewElements {
	width:800px;
	margin-left:auto;
	margin-right:auto;
	padding:0;
	padding-top:1em;
	padding-bottom:1em;
	color:#fff;
}

#preview {
	width:800px;
	margin-left:auto;
	margin-right:auto;
	background-color:#fff;
	padding:.5em;
}
input {
	font-size:12px;
}
textarea, area {
	font-size:12px;
}

</style>
</head>
<body>
<div id="inhalt">
<form action="editor.safe.php" method="post" style="width:800px; margin-left:auto; margin-right:auto; font-size:12px">
<input type="hidden" name="editor.filename" value="'.$filename.'">
<input type="hidden" name="editor.backurl" value="'.$_SESSION['editor.backurl'].'">
<input type="hidden" name="file" value="'.$_REQUEST['item'].'">

<textarea name="text1" rows="20" style="width:90%">'.$file.'</textarea>
';

if ($_REQUEST['type']=='html') {
print '
<script type="text/javascript">CKEDITOR.replace("text1")</script>
';
}
print '
<br>
';

#if ($_REQUEST['type']!='html') {
print '
<input type="submit" value="speichern" />&nbsp;&nbsp;&nbsp;
';
#}
print '
<input type="reset" value="zurücksetzen" />&nbsp;&nbsp;&nbsp;
<input type="button" value="abbrechen" onclick="location.href=\''.$_SESSION['editor.backurl'].'\'">
</form>
<div id="previewEnvelope">
	<div class="previewElements"><strong>Vorschau:</strong></div>
	<div id="preview"></div>
	<div class="previewElements"><input type="button" onclick="disablePreviev()" value="Vorschau schließen" />&nbsp;&nbsp;&nbsp;<input type="button" value="speichern" onclick="document.forms[0].submit()" />&nbsp;&nbsp;&nbsp;<input type="button" value="abbrechen" onclick="location.href=\''.$_SESSION['editor.backurl'].'\'"></div>
</div>
</div>
';
print getEndHtml();
	exit;
}

if ($_REQUEST['type']=='flat') {
	$file=file($filename);
	foreach ($file as $zeile) {
		$arItems=explode(':', $zeile);
		if ($arItems[0]=='#trennzeichen') {
			$trennzeichen=str_replace("'",'',trim($arItems[1]));
			break;
		}
	}

	if (! isset($trennzeichen)) {
		die("Fatal: Das Trennzeichen konnte nicht festgestellt werden. Die Datei '..' muss eine Zeile #trennzeichen:';', #trennzeichen:' ' oder #trennzeichen:':' enthalten.");
	}

	$str='<html>
<head>
</head>
<body>
<div id="inhalt">
<h2>Achtung: Sie editieren Einstellungsdateien!</h2>
<p><strong>Sie können hier bei unbedachten Änderungen großen Schaden anrichten.</strong></p>
<h4>Bitte beachten: Das Trennzeichen ist: "'.htmlentities($trennzeichen).'"</h4>
<p>Die Verwendung dieses Zeichens führt zu einem Fehler!</p>
<table style="width:100%">';

	$zeileNr=0;
	foreach ($file as $zeile) {
		$arItems=explode($trennzeichen, $zeile,4);
		if ($arItems[0]!="#trennzeichen:'") {
			if ($arItems[0][0]!='#') {
				$str.='<tr>';
				$spalteNr=0;
				foreach ($arItems as $item) {
					$str.='<td><input name="item['.$zeileNr.']['.$spalteNr.']" style="width:100%" type="text" value="'.$item.'"></td>';
					$spalteNr++;
				}
				$str.='</tr>';
				$zeileNr++;
			} else {
				$str.='<tr>';
				foreach ($arItems as $item) {
					$str.='<td>'.$item.'</td>';
				}
				$str.='</tr>';
			}
		}

	}
	$str.='
</table>
</div>

';
}

print getEndHtml().$str;

function getEndHtml() {

return '
<div id="menueLinks" style="position:absolute;top:80px;left:10px;">
	<h4 style="background-image:url(../skins/fastix/img/background-kurz.png);	background-repeat:no-repeat; padding:.5em; padding-top:.3em; padding-bottom:.2em">Administration:</h4>
	<ul>
		<li style="list-style-type:none;"><a href="./">Administration</a></li>
	</ul>
</div> <!-- menueLinks -->
<img style="height:80px;position:absolute;top:0px;left:0px;border:0" src="../skins/fastix/img/fastix_org.png" alt="">
</body>
</html>
';
}

?>