<?php
/*
liefert folgende Funktionen:

fastixDebugArray($ar);
fastixCsvToArray($filename,$trenner=';', $remark='#', $maxcols=3)
fastixCsvToAssocArray($filename, $trenner=';', $remark='#', $maxCols=3)
fastixReadRemarksFromCsvAsArray ($filename,$remark='#')
fastixArrayToCsvFile($ar, $filename, $trenner=';', $remark='#')
fastixCheckFile(filename,'[r]eadable|[w]ritable')
fastixGetLinksFromCsv ($enclosedHTML,$filename,$trenner=';',$remark='#' )

fastixGetNewArtikelNr();
fastixGetKategorien ();
fastixFormatTimeString($t)
fastixGetFilnamesInDirAsArray($dir);
fastixCheckVerboteneSeiten($str);
fastixCloseTags($html);
fastixCheckSetup();
TestAndSendCache();
WriteCache($html);
fastixClearCache ();
*/
error_reporting(E_ALL);

$file='config/fastix_cms.ini';
if (file_exists($file)) {
	$GLOBALS['CONFIG']=parse_ini_file($file);
} else {
	$file='../'.$file;
	if (file_exists($file)) {
		$GLOBALS['CONFIG']=parse_ini_file($file);
	} else {
		die ('Fatal: Konfiguration konnte nicht gelesen werden.');
	}
}



if (! isset ($GLOBALS['CONFIG'])) {
	die('Fatal: Konfigurationsdatei konnte nicht gelesen werden.');
}

$dummy=ini_set('upload_max_filesize', '4M');
$dummy=ini_set('session.gc_maxlifetime', '86400');
$GLOBALS['httpBase']=getHttpDir();
$arTemplate['http_base']=$GLOBALS['httpBase'];

$GLOBALS['fsBase']=getcwd();
$arDirs=array('/plugins', '/cms');

if (! $GLOBALS['fsBase']) {
	$arFsDir=explode('/',$_SERVER['SCRIPT_FILENAME']);
	array_pop($arFsDir);
	$str=str_replace('//','/',(implode('/',$arFsDir).'/'));
	$GLOBALS['fsBase']=str_replace($arDirs,'',$str);
} else {
	$GLOBALS['fsBase']=str_replace($arDirs,'',$GLOBALS['fsBase']);
}

function getHttpDir() {
	$arDirs=explode('/', $_SERVER['SCRIPT_NAME']);
	array_pop($arDirs);
	return 'http://'.$_SERVER['HTTP_HOST'].str_replace('//','/',(implode('/',$arDirs).'/'));
}


function fastixDebugArray($ar, $ex=false) {
	
	if (! isset($GLOBALS['fastixDebug']) || ! $GLOBALS['fastixDebug']) {
		print '<div style="position:absolute;top:0;left0;z-index:99;padding:1em;color:#000000;background-color:#fff0f0;font-size:12px">';
		$GLOBALS['fastixDebug']=true;
	}
	
	print '<pre style="border:2px solid red;background-color:#fff0f0;font-size:12px">';
	print_r($ar);
	print '</pre>';
	if ($ex) {
		print '</div>';
		exit;
	}
}

function fastixCsvToArray($filename, $trenner=';', $remark='#', $maxCols=3) {
	$dummy=fastixCheckFile($filename,'r');
	$ar=array();
	$lines = file($filename);
	foreach ($lines as $line) {
		$line=trim($line);
		if (isset($line[0]) && $remark != $line[0]) {
			$arLineTemp=explode($trenner, $line, $maxCols);
			$arLine=array();
			foreach ($arLineTemp as $elem) {
				$arLine[]=trim($elem);
			}
			$ar[]=$arLine;
		}
	}
	return $ar;
}

function fastixCsvToAssocArray($filename, $trenner=';', $remark='#', $maxCols=3) {
	#die($filename);
	$dummy=fastixCheckFile($filename,'r');
	$ar=array();
	$lines = file($filename);
	foreach ($lines as $line) {
		$line=trim($line);
		if ($remark != $line[0]) {
			$arLineTemp=explode($trenner, $line, $maxCols);
			$arLine=array();
			for ($i=0;$i < $maxCols; $i++) {
				$arLineTemp[$i]=trim($arLineTemp[$i]);
				if ($i == 0) {
					$assoc=$arLineTemp[$i];
				} else {
					if ($maxCols == 2) {
						$ar[$assoc]=$arLineTemp[$i];
					} else {
						$ar[$assoc][$i]=$arLineTemp[$i];
					}
				}
			}
		}
	}
	return $ar;
}

function fastixReadRemarksFromCsvAsArray ($filename,$remark='#') {
	$dummy=fastixCheckFile($filename,'r');
	$ar=array();
	$ar[0]='';
	$lines = file($filename);
	foreach ($lines as $line) {
		$line=trim($line);
		if ($remark == $line[0]) {
			$ar[]=$line;
		}
	}
	return $ar;
}

function fastixArrayToCsvFile($ar, $filename, $trenner=';', $remark='#') {
	$dummy=fastixCheckFile($filename,'w');
	$arDateiInhalt=fastixReadRemarksFromCsvAsArray($filename,$remark='#')."\n";
	foreach ($arDateiInhalt as $zeile) {
		$arItems=explode(':', $zeile);
		if ($arItems[0]=='#trennzeichen') {
			$trenner=str_replace("'",'',trim($arItems[1]));
		}
	}
	foreach ($ar as $arLine) {
		$strLine='';
		for ($i=0;$i<count($arLine);$i++) {
			$arLine[$i]=str_replace($trenner,'',trim($arLine[$i]));
			
		}
		$arLineNeu=implode($trenner, $arLine)."\n";
		$arDateiInhalt[]=$arLineNeu;
	}
	$strDateiInhalt=implode("\n",$arDateiInhalt);
	$FH=fopen($filename,'w');
	fwrite($FH, $strDateiInhalt);
}

function fastixCheckFile($filename, $right='r') {
	#die($filename);
	if(!is_file($filename)) {
		die ('Fatal: '.$filename.' ist keine Datei!!!'."\n");
	}
	
	if(!is_readable($filename)) {
		die ('Fatal: '.$filename.' ist nicht lesbar!'."\n");
	}
	
	if ('w'==strtoupper(substr($right,1))) {
		die ('Fatal: '.$filename.' ist nicht schreibbar!'."\n");
	}
	return 0;
}

function fastixArrayToLinks($enclosedHTML,$ar) {
	$str='';
	$enclosed=trim($enclosedHTML);
	if (count($ar)) {
		foreach ($ar as $arLink) {
			$link='';
			if (2 > count($arLink)) {
				return false;
			}
			if ( (2==count($arLink)) || ''==$arLink[2] ){
				$link='<a href="'.$arLink[1].'">'.$arLink[0].'</a>';
			} else {
				$link='<a href="'.$arLink[2].'" target="'.$arLink[1].'">'.$arLink[0].'</a>';
			}
			
			if ('br'==$enclosedHTML) {
				$link.='<br />';
			}
			
			if ($enclosedHTML) {
				$link='<'.$enclosedHTML.'>'.$link.'</'.$enclosedHTML.'>';
			}
			$str .= $link."\n";
		}
	}
	return $str;
}

function fastixGetGalerieFromCsv($filename, $trenner=' ', $remark='#', $maxCols=4 ) {
	$ar=fastixCsvToArray($filename, $trenner, $remark, $maxCols);
	$str='';
	foreach ($ar as $arGalerieEintrag) {
		$imgUrl		= trim($arGalerieEintrag[0]);
		$linkUrl	= trim($arGalerieEintrag[1]);
		@$linkTarget	= trim($arGalerieEintrag[2]);
		@$extraText 	= trim($arGalerieEintrag[3]);
		@$alt		= trim($arGalerieEintrag[3]);
		if ('' !=$linkTarget) {
			$linkTarget=' target="'.$linkTarget.'"';
		}
		if ('' !=$extraText) {
			$extraText='<div class="extraText"><a href="'.$linkUrl.'"'.$linkTarget.' alt="'.$alt.'">'.$extraText.'</a></div>';
		}
		$str.='<div>'.$extraText.'<a href="'.$linkUrl.'"'.$linkTarget.'><img src="'.$imgUrl.'"></a></div>'."\n";
	}
	return $str;
}


function fastixGetLinksFromCsv ($enclosedHTML,$filename,$trenner=';',$remark='#', $maxCols=3) {
	return fastixArrayToLinks($enclosedHTML,fastixCsvToArray($filename,$trenner,$remark,$maxCols));
}

function fastixGetNewArtikelNr () {
	$filename='data/artikel.csv';
	if (! file_exists($filename)) {
		$filename='../'.$filename;
	}
	$dummy=fastixCheckFile($filename,'r');
	$ar=fastixCsvToArray($filename);
	$max=0;
	foreach ($ar as $tupel) {
		if ($max < $tupel[0]) {
			$max=$tupel[0];
		}
	}
return ($max+1);
}

function fastixGetKategorien () {
	$filename='data/kategorien.csv';
	if (! file_exists($filename)) {
		$filename='../'.$filename;
	}
	$dummy=fastixCheckFile($filename,'r');
	$ar=fastixCsvToAssocArray($filename, $trenner=';', $remark='#', $maxCols=4);
	#fastixDebugArray($ar, true);
	return $ar;
}

function fastixGetKategorienSelector ($name="kategorie", $selected=false) {
	$ar=fastixGetKategorien();
	$arKeys=array_keys($ar);
	$str='<select name="'.$name.'">';
	foreach ($arKeys as $key) {
		
		$kategorie=$ar[$key][3];
		$ifSelected='';
		if ($selected && ($selected==$key || $selected==$kategorie)) {
			$ifSelected=' selected="selected"';
		}
		$str.='<option value="'.$key.'"'.$ifSelected.'>'.$kategorie.'</option>';
	}
return $str.'</select>';
}

function fastixGetArtikelArray($nr=false) {
	$filename='data/artikel.csv';
	if (! file_exists($filename)) {
		$filename='../'.$filename;
	}
	$dummy=fastixCheckFile($filename,'r');
	$ar=fastixCsvToArray($filename, $trenner=';', $remark='#', $maxCols=6);
	if (false===$nr) {
		return $ar;
	} else {
		foreach ($ar as $arArtikel) {
			if ($nr==$arArtikel[0]) {
				return	$arArtikel;
			}
		}
	}
	die ('Die Funktion "fastixGetArtikelArray" kann nichts zurückliefern. Artikelnummer ist: '.htmlentities($nr));
}

function fastixFormatTimeString($t) {
	$H=date('H',$t);
	$i=date('i',$t);
	
	if (($H=='00' AND $i=='00') OR $H==23 AND $i==59) {
		$str= date('d.m.Y', $t);
	} else {
		$str= date('d.m.Y H:i', $t).' Uhr';
	}
	if (date('Ymd',$t)==date('Ymd')) {
		$str='<strong>heute</strong>, '.$str;
	}
	return $str;
}

function fastixGetFilnamesInDirAsArray($dir) {
	$ar=array();
	$DIR=dir($dir);
	while (false !== ($entry = $DIR->read())) {
		if (true
			AND '..' != $entry 
			AND '.'  != $entry 
			AND is_file($dir.'/'.$entry)
		) {
			$ar[]=$entry;
		}
	}
	$DIR->close();
	return $ar;
}

function fastixCheckVerboteneSeiten($str) {
	$verboten=array();
	$verboten[]='htacces';
	$verboten[]='passwd';
	$verboten[]='roots.csv';
	$verboten[]='templates/';
	$verboten[]='cms/';
	$verboten[]='ckeditor/';
	$verboten[]='config/';
	$verboten[]='css/';
	$verboten[]='.php';
	$verboten[]='../..';
	
	foreach ($verboten as $nogo) {
		if (strpos($str, $nogo)) {
			die('Ups! Eine Datei diesen Namens darf nicht angelegt oder bearbeitet werden.');
		}
	}
}

function fastixCloseTags($html) {
	preg_match_all('#<([a-z]+)(?: .*)?(?<![/|/ ])>#iU', $html, $result);
	$openedtags = $result[1];
	
	preg_match_all('#</([a-z]+)>#iU', $html, $result);
	$closedtags = $result[1];
	
	$len_opened = count($openedtags);
	if (count($closedtags) == $len_opened) {
		return $html;
	}
	$openedtags = array_reverse($openedtags);
	for ($i=0; $i < $len_opened; $i++) {
		if (!in_array($openedtags[$i], $closedtags)){
			$html .= '</'.$openedtags[$i].'>';
		} else {
			unset($closedtags[array_search($openedtags[$i], $closedtags)]);
		}
	}
return $html;
}

function fastixCheckSetup() {
	if (file_exists ('config/fastix_cms.ini')) {
		if (0==$GLOBALS['CONFIG']['SetupPassed']) {
			die ('
<html>
<body>
<h1>Bitte zuerst Setup ausf&uuml;hren.</h1>
Hilfe hierzu finden Sie unter der URL <a href="http://fastix.org/fastix-cms/?seite=Setup">http://fastix.org/fastix-cms/?seite=Setup</a>.
</body>
</html>
');
		}
	}
}

function nStellig ($zahl, $stellen) {
        return sprintf('%0'.$stellen.'s', $zahl);
}

function TestAndSendCache() {
	if (is_dir('./data/cache/'))  {
		$CacheDir='./data/cache/'; 
	} elseif (is_dir('../data/cache/')) {
		$CacheDir='../data/cache/'; 
	}
	if (! isset($_SERVER['HTTP_ACCEPT_ENCODING'])) {
		$_SERVER['HTTP_ACCEPT_ENCODING']=false;
	}
	if (false===strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')) {
		$CacheFile=$CacheDir.md5($_SERVER["REQUEST_URI"]);
		if (is_file($CacheFile) && is_readable($CacheFile)) {
			readfile($CacheFile);
			exit;
		}
	} else {

		$CacheFile=$CacheDir.md5($_SERVER["REQUEST_URI"]).'.gz';
		if (is_file($CacheFile) && is_readable($CacheFile)) {
			header('Vary: Accept-Encoding');
			header('Content-Encoding: gzip');	
			readfile($CacheFile);
			exit;
		}

	}
}

function WriteCache($html) {
	if (is_dir('./data/cache/'))  {
		$CacheDir='./data/cache/'; 
	} elseif (is_dir('../data/cache/')) {
		$CacheDir='../data/cache/'; 
	}
	$CacheFile=$CacheDir.md5($_SERVER["REQUEST_URI"]);
	if (! file_put_contents($CacheFile,$html."\n".'<!-- cached: '.date('Y-m-d H:i:s').' -->')) {
		 return false;
	}
	$CacheFile=$CacheDir.md5($_SERVER["REQUEST_URI"]) . '.gz';
	return file_put_contents($CacheFile,gzencode($html."\n".'<!-- zipped and cached: '.date('Y-m-d H:i:s').' -->'));
	
}


function fastixClearCache () {
	if (is_dir('../data/cache/')) { 
		$DIR=dir('../data/cache/'); 
	} else {
		die('<div>Chache-Verzeichnis ung&uuml;ltig</div>');
	}
	while (false !== ($entry = $DIR->read())) {
		if ($entry != '.' && $entry != '..') {
			unlink ('../data/cache/'.$entry);
		}
	}
}