<?php
#finder.php

include __DIR__ . '/cms/fastix_funktionen.php';

if (! isset($_GET['q']) || ''==isset($_GET['q'])) {
	include('index.php');
	exit;
}


if (ini_get('magic_quotes_gpc')) {
	$_GET['q']=stripslashes($_GET['q']);
}
$_GET['q'] = stripFirstSlashes ($_GET['q']);
$funde=array();

$arKategorien=fastixGetKategorien();
$arKeys=array_keys($arKategorien);

foreach ($arKeys as $key) {
	$str=$arKategorien[$key][3];
	if (false
		|| $str            ==$_GET['q']
		|| strtoupper($str)==strtoupper($_GET['q'])
		|| myClear($str)   == myClear($_GET['q'])
	) {
		$funde[]['k']=$key;
	}
}

$arArtikel=fastixCsvToAssocArray($GLOBALS['fsBase'].'/data/artikel.csv',';','#',6);;
$arKeys=array_keys($arArtikel);
foreach ($arKeys as $key) {
	$str = $arArtikel[$key][5];
	if (
		($str            ==$_GET['q']
		|| strtoupper($str)==strtoupper($_GET['q'])
		|| myClear($str)   == myClear($_GET['q'])
		)

	 	&& (
	 	1==$arArtikel[$key][2]
	 	)
	 ){
	 	$ar['a']=$key;
	 	$ar['k']=$arArtikel[$key][1];
		$funde[]=$ar;
		unset($ar);
	}
}
#fastixDebugArray($funde, true);

if (0==count($funde)) {
	header('Error: 404');
	header('Location: '.$GLOBALS['httpBase'].'?seite=Error+404.htm');
} else if (1==count($funde)) {
	if (isset($funde[0]['seite'])) {
		$_GET['seite']=$funde[0]['seite'];
		$_REQUEST['seite']=$funde[0]['seite'];
	} else {
		if (isset($funde[0]['k'])) {
			$_GET['k']=$funde[0]['k'];
			$_REQUEST['k']=$funde[0]['k'];
		}
		if (isset($funde[0]['a'])) {
			$_GET['a']=$funde[0]['a'];
			$_REQUEST['a']=$funde[0]['a'];
		}
	}
	require_once('index.php');
	exit;
}

include_once 'cms/fastix_template.php';
$GLOBALS['CONFIG']['LoadPlugin_UrlOptimize']=false;
################################

#fastixDebugArray($funde, true);
$arTemplate['Seiteninhalt']='
<h4>Das Ergebnis der Suche ist leider nicht eindeutig</h4>
<h2>Meinten Sie:</h2>
<ul>
';
foreach ($funde as $arFund) {
	#fastixDebugArray($arFund, false);
	if (isset($arFund['a']) && isset($arFund['k'])) {
		$arTemplate['Seiteninhalt'].='
<li>
	<a href="'.$arTemplate['http_base'].'index.php?k='.$arFund['k'].'&amp;a='.$arFund['a'].'">den Artikel <q>'.htmlentities($_GET['q']).'</q></a>
</li>
';
	} else if (isset($arFund['k'])) {
		$arTemplate['Seiteninhalt'].='
<li>
	<a href="'.$arTemplate['http_base'].'index.php?k='.$arFund['k'].'">die Kategorie <q>'.htmlentities($_GET['q']).'</q></a>
</li>
';
	} else if (isset($arFund['seite'])) {
		$arTemplate['Seiteninhalt'].='
<li>
	<a href="'.$arTemplate['http_base'].'index.php?seite='.$arFund['seite'].'">die Seite <q>'.htmlentities($_GET['q']).'</q></a>

</li>
';
	}
}
$arTemplate['Seiteninhalt'].='
</ul>
';
#fastixDebugArray($funde, true);
################################

# Template:
$arTemplate['TemplateFile']=$GLOBALS['fsBase'].'/skins/'.$GLOBALS['CONFIG']['skin'].'/templates/standard.html';
$arTemplate['imgDir']=$GLOBALS['httpBase'].'/skins/'.$GLOBALS['CONFIG']['skin'].'/img/';
$arTemplate['CSSFile']=$GLOBALS['httpBase'].'/skins/'.$GLOBALS['CONFIG']['skin'].'/css/css.php';

$arKategorien=fastixGetKategorien();
$KategorieName='';
$arKategorienLinks=array();
foreach ($arKategorien as $tupel) {
	$arKategorienLinksArray[]=array($tupel[3],$tupel[2],$tupel[1]);
}



$arTemplate['Seitentitel']='<a href="./">'.$GLOBALS['CONFIG']['NameStartSeite'].'</a> &hArr; Finder';
$arTemplate['SeitentitelHTML']=strip_tags($GLOBALS['CONFIG']['NameStartSeite']).' :: Finder';
$arTemplate['SeitentitelKurz']='Finder';

$arTemplate['serviceMenue']=fastixGetLinksFromCsv ('li',$GLOBALS['fsBase'].'/data/servicemenue.csv', $trenner=';', $remark='#', $maxCols=3 );

$arTemplate['Menue1']=fastixArrayToLinks ('li',$arKategorienLinksArray);

$arTemplate['Menue2']=fastixGetLinksFromCsv ('li','data/menue2.csv', $trenner=';', $remark='#', $maxCols=3 );

$arTemplate['Menue3']=fastixGetLinksFromCsv ('li', 'data/menue3.csv', $trenner=';',$remark='#' );

#$arTemplate['Galerie']=fastixGetGalerieFromCsv('data/galerie.csv', $trenner=' ', $remark='#', $maxCols=4 );


PrintFastixTemplateReplace($arTemplate);
exit;



function stripFirstSlashes ($str) {
	$str2=ltrim($str,'/');
	if  ($str2 != $str) {
		$str2=stripFirstSlashes ($str2);
	}
	return $str2;
}



function myClear($str) {
	$umlaute=array('ä', 'ü', 'ö', 'Ä', 'Ü', 'Ö', 'ß');
	$ersetz=array('ae','ue','oe','Ae','Ue','Oe','ss');
	return preg_replace('/[^a-zA-Z0-9 -]/','-',str_replace($umlaute, $ersetz, strip_tags($str)));
}