<?php
/*
kommentar.speichern.php
*/

if (! isset($_COOKIE['t'])) {
   die ("Bitte aktivieren Sie Cookies.");
} elseif (0==$_COOKIE['t']) {
   die ("Scheinbar haben Sie diesen Kommentar schon eingetragen.");
}
setcookie("t", 0);

include_once 'cms/fastix_funktionen.php';
$filename = "data/Kommentare/next_nr";
$nr=file_get_contents($filename);
file_put_contents($filename, $nr+1);

#nr;artikel;date_time;status;ip;name

if (! isset($_POST['kommentar'])) { 
	# error
	die ("Es wurde kein Kommentar uebergeben.");
}

if (! isset($_POST['artNr'])) { 
	# error
	die ("Es wurde keine ArtikelNr. uebergeben.");
}

# Spamfilter
$arSpam[]=array('[url=',  '[link=');
$arSpam[]=array('viagra');

$test=strtolower($_POST['kommentar']);

$bolSpam=false;
foreach ($arSpam as $arSpammerkmal) {
	$bolSpamItem=true;
	foreach ($arSpammerkmal as $item) {
		if (false === strpos($test,$item)) {
			$bolSpamItem=false;	
		}
	}
	if ($bolSpamItem) {
		$bolSpam=$bolSpamItem;
	}
}

if ($bolSpam) {
	header('Error: 403 Forbidden');
	die ('<html><head><title>Forbidden</title></head><body><h1>403 Forbidden</h1><p>Nobody need your fucking spam!</p></body></html>');
	
}
unset ($test);

$_POST['artNr']=$_POST['artNr']*1;

$name='Anonymous';
$dateTime=date('Y m d H i s');
$ip=$_SERVER['REMOTE_ADDR'];
$artNr=$_POST['artNr']*1;
$arBadwordsTmp=file('data/badwords');
$arBadwords=array();
foreach ($arBadwordsTmp as $str) {
	$arBadwords[]='/'.trim($str).'/i';
}
unset($arBadwordsTmp);

if (get_magic_quotes_gpc()) {
	$allowedTags='<b><strong><u><s><i><br><q><cite><blockquote>';
	$text=nl2br(strip_tags(stripslashes(trim($_POST['kommentar'])),$allowedTags));
	if (class_exists('tidy')) {
		$tidy = new tidy();
		$text=$tidy->repairString($text);
	}
	if (isset($_POST['name']) && $_POST['name'] != 'Ihr Name') {
		$name=htmlspecialchars(strip_tags(stripslashes(trim($_POST['name']))));	
	}
} else {
	$text=nl2br(strip_tags(trim($_POST['kommentar']),$allowedTags));
}
$text=fastixCloseTags(preg_replace($arBadwords, '[gelöscht]', $text));

#nr;artikel;date_time;status;name
$str="\n$nr;$artNr;$dateTime;0;$name";
file_put_contents('data/kommentare.csv', $str, FILE_APPEND);
fastixCheckVerboteneSeiten($nr);
file_put_contents('data/Kommentare/'.$nr, $text);

#Laden des Plugins
if ( true 
	&& isset($GLOBALS['CONFIG']['LoadPlugin_MailKommentare']) 
	&& $GLOBALS['CONFIG']['LoadPlugin_MailKommentare']
)  {
	require_once 'plugins/MailKommentare.php';
	MailKommentare($nr, $_POST['artNr'], $text, $name, $ip);
}

?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>Kommentar wird geprüft</title>
</head>
<body><p>Ihr Kommentar wurde gespeichert und wird nach einer Prüfung hier erscheinen.</p></body>
<script type="text/javascript">
function run() {
	alert("Ihr Kommentar wurde gespeichert und wird nach einer Prüfung hier erscheinen.");
	return true;
}

run();
location.href="<?php echo $_POST['GoTo']; ?>";
</script>
</html>

