<?php
#termine.php
error_reporting(E_ALL);
include_once 'cms/fastix_funktionen.php';
include_once 'cms/fastix_template.php';

# Daten einlesen

$arTermine=fastixCsvToArray('data/termine.csv', ';', '#', 5);
#Ermitteln des Startzeitpunktes:

$arAssocTermine=array();
foreach ($arTermine as $tmp) {
	$tmp[0]=strtotime($tmp[0]);
	$tmp[1]=strtotime($tmp[1]);
	$arAssocTermine[$tmp[1]]=$tmp;
}
unset($arTermine);

$arKeys=array_keys($arAssocTermine);
$arAlteTermine=array();
$arAktelleTermine=array();

$heute=strtotime(date('Y-m-d'));

foreach ($arKeys as $key) {
	if ($key >=$heute) {
		$arAktelleTermine[$key]=$arAssocTermine[$key];
	} else {
		$arAlteTermine[$key]=$arAssocTermine[$key];
	}
}
unset($arAssocTermine);

#Einlesen der Artikel für Test
$arArtikel=fastixCsvToAssocArray('data/artikel.csv', ';', '#', 6);
#fastixDebugArray($arArtikel, false);


if (count($arAktelleTermine)) {
	ksort($arAktelleTermine,SORT_NUMERIC);
	#fastixDebugArray($arAktelleTermine, false);
	$strAktelleTermine='<h2>Aktuelle Termine:</h2>'.formatTermine($arAktelleTermine,$arArtikel);
	#fastixDebugArray($strAktelleTermine, false);
} else {
	$strAktelleTermine=false;
}
unset($arAktelleTermine);



if ($GLOBALS['CONFIG']['ZeigeAlteEintraege'] && count($arAlteTermine)) {
	krsort($arAlteTermine,SORT_NUMERIC);
	#fastixDebugArray($arAlteTermine, false);
	$strAlteTermine='<h2>Frühere Termine:</h2>'.formatTermine($arAlteTermine,$arArtikel);
	#fastixDebugArray($strAlteTermine, false);
} else {
	$strAlteTermine=false;
}
unset($arAlteTermine);

unset($arArtikel);
#fastixDebugArray($strAlteTermine, true);

$arTemplate['Seiteninhalt']=file_get_contents('data/Kategorien/Termine.html').$strAktelleTermine.$strAlteTermine;




# Template:
$arTemplate['TemplateFile']='skins/'.$GLOBALS['CONFIG']['skin'].'/templates/standard.html';
$arTemplate['imgDir']='skins/'.$GLOBALS['CONFIG']['skin'].'/img/';
$arTemplate['CSSFile']='skins/'.$GLOBALS['CONFIG']['skin'].'/css/css.php';

$arKategorien=fastixGetKategorien();
$arKategorienLinks=array();
$arKeys=array_keys($arKategorien);
asort($arKeys);
foreach ($arKeys as $key) {
	$arKategorienLinksArray[]=array($arKategorien[$key][3],$GLOBALS['httpBase'].'./?k='.nStellig($key,6));
}

if (isset($arKategorienLinksArray)) {
	$arTemplate['Menue1']=fastixArrayToLinks ('li',$arKategorienLinksArray);
} else {
	$arTemplate['Menue1']='';
}



$arTemplate['Seitentitel']='<a href="./">'.$GLOBALS['CONFIG']['NameStartSeite'].'</a> &hArr; <a href="Termine.php">Termine</a>';
$arTemplate['SeitentitelHTML']=strip_tags($GLOBALS['CONFIG']['NameStartSeite']).' :: Termine';
$arTemplate['SeitentitelKurz']='';;

$arTemplate['serviceMenue']=fastixGetLinksFromCsv ('li','data/servicemenue.csv', $trenner=';', $remark='#', $maxCols=3 );

$arTemplate['Menue2']=fastixGetLinksFromCsv ('li','data/menue2.csv', $trenner=';', $remark='#', $maxCols=3 );

$arTemplate['Menue3']=fastixGetLinksFromCsv ('li', 'data/menue3.csv', $trenner=';',$remark='#' );

#$arTemplate['Galerie']=fastixGetGalerieFromCsv('data/galerie.csv', $trenner=' ', $remark='#', $maxCols=4 );

$arTemplate['showEdit']='.edit {display:none;}';
PrintFastixTemplateReplace($arTemplate);
exit;

function formatTermine($ar, $arArtikel) {
	$str='<ul class="Terminliste">';
	foreach ($ar as $tupel) {
		$beginn=fastixFormatTimeString($tupel[0]);
		$ende=  fastixFormatTimeString($tupel[1]);
		if ($ende==$beginn) {
			$ende='';
		} else {
			$ende=' bis '.$ende;
		}
		$ArtNr=$tupel[2];
		if (isset($arArtikel[$ArtNr]) && $arArtikel[$ArtNr][2] == 1) {
			$LinkText='<div>Weitere Informationen im Artikel: <a href="./?k='.nStellig($arArtikel[$ArtNr][1],6).'&amp;a='.nStellig($ArtNr,6).'">'.$arArtikel[$ArtNr][5].'</a></div>'."\n";
		} else {
			$LinkText="\n";
		}		
		$str.='<li>'.$beginn.$ende.': '.$tupel[3].$LinkText.'</li>';
	}
	
	$str.='</ul>';
	return $str;
}
?>