<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

if (! isset($_GET['item'])) {
 go_ahead();
}

include_once '../cms/fastix_funktionen.php';
include_once 'getAdminMenueLinks.php';


$GLOBALS['intSeitenGroesse']	= 8;
$GLOBALS['PicFile']		= '../data/bildshow.csv'; #sog. Datenbank
$GLOBALS['KatFile']		= '../data/bildshow_kategorien.csv';
$GLOBALS['PicFileDelimiter']	= '~';
$GLOBALS['PicFilesDir']		= '../bilder/';
$GLOBALS['ThumbFilesDir']	= $GLOBALS['PicFilesDir'].'thumbnails/';
$GLOBALS['originalFilesDir']	= $GLOBALS['PicFilesDir'].'original/';
$GLOBALS['ColsInThumTable']	= 2;


$search = 'http://'.$_SERVER['SERVER_NAME'];
$replace= $_SERVER['DOCUMENT_ROOT'];

$picdir   = $GLOBALS['PicFilesDir'];
$thumbdir = $GLOBALS['ThumbFilesDir'];
$origdir  = $GLOBALS['originalFilesDir'];

$arBilder=getImagesArray();
$strBilderNeu=''; 

if (0==count($arBilder)) {
	go_ahead();
}

@unlink($picdir.$arBilder[$_GET['item']]['file']);
@unlink($thumbdir.$arBilder[$_GET['item']]['file']);
@unlink($origdir.$arBilder[$_GET['item']]['file']);
unset ($arBilder[$_GET['item']]);

foreach ($arBilder AS $ar) {
	$strBilderNeu.=$ar['file'].'~'.$ar['autor'].'~'.$ar['titel'].'~~'.$ar['bildBeschreibung'].'~~'.$ar['zahl1'].'~'.$ar['zahl2'].'~'.$ar['kategorie']."\n";

}

$strBilderNeu=trim($strBilderNeu);
#print '<hr><pre>'; print $strBilderNeu; print '</pre>';exit;

$FH=fopen($GLOBALS['PicFile'],'w');
fwrite($FH, $strBilderNeu);
fclose($FH);
go_ahead();


function go_ahead() {
	header('Location: AdminBilder.php');
	exit;
}

function getImagesArray() {
	$arZeilen=file($GLOBALS['PicFile']);
	# Einlesen und Pruefen des Bilder-Arrays aus der Datei:
	$i=0; $arBilder=array();
	foreach ($arZeilen as $strZeile) {
		$arSpalten=array();
		$arSpalten=explode($GLOBALS['PicFileDelimiter'], $strZeile);
		#fastixDebugArray($arSpalten, false);
		if ( true
			AND (isset ($arSpalten[1])
			AND '' != trim($arSpalten[0]))
		) {
			$i++;
			$arBilder[$i]['file']=trim($arSpalten[0]);
			$arBilder[$i]['autor']=trim($arSpalten[1]);
			$arBilder[$i]['titel']=trim($arSpalten[2]);
			
			if (isset ($arSpalten[3])) {
				$arBilder[$i]['autorBeschreibung']=trim($arSpalten[3]); 
			} else {
				$arBilder[$i]['autorBeschreibung']=false;
			}
			
			if (isset ($arSpalten[4])) {
				$arBilder[$i]['bildBeschreibung']=trim($arSpalten[4]);
			} else {
				$arBilder[$i]['bildBeschreibung']=false;
			}
			
			if (isset ($arSpalten[5])) {
				$arBilder[$i]['bildJahr']=trim($arSpalten[5]); 
			} else {
				$arBilder[$i]['bildJahr']=false;
			}
			
			if (isset ($arSpalten[6])) {
				$arBilder[$i]['zahl1']=trim($arSpalten[6]); 
			} else {
				$arBilder[$i]['zahl1']=false;
			}
			
			if (isset ($arSpalten[7])) {
				$arBilder[$i]['zahl2']=trim($arSpalten[7]);
			} else {
				$arBilder[$i]['zahl2']=false;
			}
			
			if (isset ($arSpalten[8])) {
				$arBilder[$i]['kategorie']=trim($arSpalten[8]);
			} else {
				$arBilder[$i]['kategorie']=false;
			}
		}
	}
	return $arBilder;
}
?>