<?php
session_start();
if (! isset($_SESSION['ADMIN'])) {
	header("Location: Login.php");
	exit;
}

include_once '../cms/fastix_funktionen.php';
include_once '../cms/fastix_template.php';
include_once 'getAdminMenueLinks.php';

$arTemplate['CSSFile']='../skins/fastix/css/css.php';
$arTemplate['MenueLinks']=getAdminMenueLinks();
$arTemplate['TemplateFile']='../skins/fastix/templates/admin.html';
$arTemplate['imgDir']='../skins/fastix/img/';
$arTemplate['Seitentitel']='Kommentare verwalten';
$arTemplate['SeitentitelHTML']=$arTemplate['Seitentitel'];
$arTemplate['SeitentitelKurz']=$arTemplate['Seitentitel'];

$_SESSION['editor.backurl']='http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
$arTemplate['JavaScript']='';
$arTemplate['Seiteninhalt']='';


# Alle Artikel suchen prüfen, ob gesperrt
$arCsv=fastixCsvToAssocArray('../data/artikel.csv', ';', '#', 6);
#fastixDebugArray($arCsv, true);
$arKeys=array_keys($arCsv);
foreach ($arKeys as $key) {
	$arArtikel[$key]=$arCsv[$key][5];
	if (0==$arCsv[$key][2]) {
		$arArtikel[$key].='<br>(Dieser Artikel ist gesperrt)';
	}
}	
unset($arCsv);
#fastixDebugArray($arArtikel, true);


# # Alle Kommentare suchen prüfen, ob neu, frei oder gesperrt
$arKommentare[0]=''; # neue
$arKommentare[1]=''; # frei gegebene
$arKommentare[2]=''; # gesperrte
$counterKom[0]=0;
$counterKom[1]=0;
$counterKom[2]=0;

$buttonFreigabe='<input type="button" class="changeItem" value="frei geben" onclick="Freigabe([KOMMENTAR_NR])"';
$buttonSperren='<input type="button" class="changeItem" value="sperren" onclick="Sperre([KOMMENTAR_NR])">';
$buttonLoeschen='<input type="button" class="deleteItem" value="löschen" onclick="Loesche([KOMMENTAR_NR])">';

$buttons[0]=$buttonFreigabe.$buttonSperren.$buttonLoeschen;
$buttons[1]=$buttonSperren.$buttonLoeschen;
$buttons[2]=$buttonFreigabe.$buttonLoeschen;

$arCsv=fastixCsvToAssocArray('../data/kommentare.csv', ';', '#', 5);
#fastixDebugArray($arCsv, true);
$arKeys=array_keys($arCsv);
$arKeys=array_reverse($arKeys);
foreach ($arKeys as $key) {
	$counterKom[$arCsv[$key][3]]++;
	$lineClass='tr'.$counterKom[$arCsv[$key][3]]%2;
	$arDatum=explode(' ',$arCsv[$key][2]);
	$datum=$arDatum[2].'.'.$arDatum[1].'.'.$arDatum[0].' '.$arDatum[3].':'.$arDatum[4];
	
	$arKommentare[$arCsv[$key][3]].='
	<tr  class="Kommentartext">
		<td><strong>'.$arArtikel[$arCsv[$key][1]].'</strong></td>
		<td>'.$datum.'</td>
		<td colspan=2>'.$arCsv[$key][4].'</td>
		
	</tr>
	<tr>
		<td colspan="3" class="bigtext">'.file_get_contents('../data/Kommentare/'.$key).'</td>
		<td style="vertical-align:bottom">'.str_replace('[KOMMENTAR_NR]',$key,$buttons[$arCsv[$key][3]]).'</td>
	</tr>	
';	
}
unset ($arArtikel, $buttons, $arCsv, $arKeys);

if ('' !=$arKommentare[0]) {
	$arKommentare[0]='
	<tr>
		<th colspan="4" class="superTh">
			<strong>Neue Kommentare:</strong>
		</th>
	</tr><tr>
		<th class="text">Artikel:</th>
		<th class="text" style="width:9em">Datum, Uhrzeit:</th>
		<th class="text" style="width:10%">Name:</th>
		<th class="text" style="width:5%">Aktion:</th>
	</tr>
'.$arKommentare[0];
} else {
	$arKommentare[0]='
	<tr>
		<th colspan="4" class="superTh">
			<strong>Keine neue Kommentare:</strong>
		</th>
	</tr><tr>	
		<td colspan="4">
			Derzeit sind keine neuen Kommentare vorhanden.
		</td>
	</tr>	
';
}

if ('' !=$arKommentare[1]) {
	$arKommentare[1]='
	<tr>
		<th colspan="4" class="superTh">
			<strong>Bereits frei gegebene Kommentare:</strong>
		</th>
	</tr><tr>
		<th class="text">Artikel:</th>
		<th class="text">Datum, Uhrzeit:</th>
		<th class="text">Name:</th>
		<th class="text">Aktion:</th>
	</tr>
'.$arKommentare[1];
}

if ('' !=$arKommentare[2]) {
	$arKommentare[2]='
	<tr>
		<th colspan="4" class="superTh">
			<strong>Gesperrte Kommentare:</strong>
		</th>
	</tr><tr>
		<th class="text">Artikel:</th>
		<th class="text">Datum, Uhrzeit:</th>
		<th class="text">Name:</th>
		<th class="text">Aktion:</th>
	</tr>
'.$arKommentare[2];
}


$arTemplate['Seiteninhalt']='
<table class="Kommentartabelle">
	'.$arKommentare[0].'
	'.$arKommentare[1].'
	'.$arKommentare[2].'
</table>
';

if (isset($_SESSION['lastmsg'])) {
	$arTemplate['JavaScript']='
	<script type="text/javascript">
		alert("'.$_SESSION['lastmsg'].'")
	</script>
';
	unset($_SESSION['lastmsg']);
}
$arTemplate['JavaScript'].=file_get_contents('AdminKommentare.js');

PrintFastixTemplateReplace($arTemplate);
exit;


?>