<?php
/*
plugins/FeedGenerator.php
*/

require_once '../cms/fastix_funktionen.php';

$spezDirs=array('/plugins', '/cms');
$GLOBALS['fsBase']   = str_replace($spezDirs,'',$GLOBALS['fsBase']); 
$GLOBALS['httpBase'] = str_replace($spezDirs,'',$GLOBALS['httpBase']);

FeedGenerator ();



function FeedGenerator () {
	$rssFilename=$GLOBALS['fsBase'].'/data/feed.rss';
	$sitemapFilename=$GLOBALS['fsBase'].'/sitemap.txt';
	$sitemap=$GLOBALS['httpBase']."\n";
	$arKategorien=fastixGetKategorien();
	#fastixDebugArray($arKategorien, true);
	foreach ($arKategorien as $ar) {
		$sitemap .= $GLOBALS['httpBase'].'?k='.nStellig(substr($ar[1], 3,1),6)."\n";
	}


	$filename='';
	$arArtikel=fastixCsvToAssocArray($GLOBALS['fsBase'].'/data/artikel.csv',';','#',6);
	#fastixDebugArray($arArtikel, false);
	$intAnZahlArtikel=count($arArtikel);
	
	
	$rssItemModell='
	<item>
		<pubDate>[PUPDATE_RFC822]</pubDate>
		<title>[TITLE]</title>
		<guid isPermaLink="false">[TITLE]</guid>
		<description>[TEXT]</description>
		<link>[LINK]</link>
	</item>
';
	
	$description=trim(substr (strip_tags(clearEntities(file_get_contents($GLOBALS['fsBase'].'/data/spezialseiten/index.html'))),0,400));
	
	
	$rss="<?xml version='1.0' encoding='UTF-8'?>
<rss version='2.0' xmlns:atom='http://www.w3.org/2005/Atom'>
<channel>
	<atom:link rel='self' href='".$GLOBALS['httpBase']."SendFeed.php' type='application/rss+xml' />
	<lastBuildDate>".date('r')."</lastBuildDate>
	<ttl>600</ttl>
	<title>".clearEntities(trim(strip_tags($GLOBALS['CONFIG']['TitelStartSeite'])))."</title>
	<category>Newspapers</category>
	<language>de</language>
	<description>$description</description>
	<link>http://".$_SERVER['HTTP_HOST']."/</link>
	<generator>Des fastix kleines CMS, Plugin FeedGenerator</generator>
";	
	
	
	$arSearch=array(
		'[PUPDATE_RFC822]',
		'[UPDATED_ATOM]',
		'[KATEGORIELINK]',
		'[KATEGORIENAME]',
		'[TITLE]',
		'[TEXT]',
		'[LINK]',
		'[AUTOR]'
	);
	
	
	$arKeys=array_keys($arArtikel);
	foreach ($arKeys as $key) {
		if (1==$arArtikel[$key][2]) {
			$filename=$GLOBALS['fsBase'].'/data/Artikel/'.$key.'.html';
		
			$arReplace=array( 
				getPUPDATE_RFC822($filename),
				getUPDATED_ATOM ($filename),
				$GLOBALS['httpBase'].'?k='.nStellig($arArtikel[$key][1],6),
				$arKategorien[$arArtikel[$key][1]][3],
				clearEntities(trim(strip_tags($arArtikel[$key][5]))),
				trim(substr (strip_tags(clearEntities(file_get_contents($filename))),0,400)).'...',
				$GLOBALS['httpBase'].'?k='.nStellig($arArtikel[$key][1],6).'&amp;a='.nStellig($key,6),
				$arArtikel[$key][3]	
			);
			#fastixDebugArray($arReplace, false);
			$rss.=str_replace($arSearch, $arReplace, $rssItemModell);
			$sitemap .= $GLOBALS['httpBase'].'?k='.nStellig($arArtikel[$key][1],6).'&amp;a='.nStellig($key,6)."\n";
		}
	}
	#die("<pre>$sitemap");
	if (true 
		&& 1==$GLOBALS['CONFIG']['LoadPlugin_UrlOptimize']*1 
		&& file_exists('../plugins/UrlOptimize.php')
	) {
		require_once '../plugins/UrlOptimize.php';
		$rss = UrlOptimize($rss);
		$sitemap=UrlOptimize($sitemap);
	}
	
	$rss.='
</channel>
</rss>';
	file_put_contents($rssFilename, $rss) or die ('RSS nicht geschrieben');
	file_put_contents($sitemapFilename, $sitemap)  or die ('Sitemap nicht geschrieben');
}



function getPUPDATE_RFC822($filename) {
	return date('r', filectime($filename));
}

function getUPDATED_ATOM ($filename) {
	return date('c', filemtime($filename));
}

function clearEntities ($str) {
	$arSearch = array('&auml;','&Auml;','&ouml;','&Ouml;','&uuml;','&Uuml;','&szlig;', '&nbsp;');
	$arReplace= array('ä',     'Ä',     'ö',     'Ö',     'ü',     'Ü',     'ß',      ' ');
	return str_replace($arSearch, $arReplace, $str);
}